//load css
let link = document.createElement('link');
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = '/bil24-wp-script/custom.css';
document.head.appendChild(link);
let linkChoices = document.createElement('link');
linkChoices.rel = 'stylesheet';
linkChoices.type = 'text/css';
linkChoices.href = '/bil24-wp-script/choices/choices.min.css';
document.head.appendChild(linkChoices);


//create filters
let elemInputs = '<div class="my_wrapper"><div class="wrapper__inputs"><select class="select cities-select" placeholder="Город"><option value="" selected>Город</option></select><select class="select venues-select"><option value="">Площадка</option></select><select class="select kinds-select"><option value="">Виды</option></select></div><div class="wrapper__events"></div></div>';
document.querySelector(".bil24").insertAdjacentHTML('afterend', elemInputs);


//load choices.js
let prom = new Promise(function(resolve, reject){
    let scriptEle = document.createElement("script");
    scriptEle.setAttribute("src", "/bil24-wp-script/choices/choices.min.js");
    scriptEle.setAttribute("type", "text/javascript");
    document.head.appendChild(scriptEle);
    scriptEle.addEventListener("load", () =>{
        resolve();
    });
});


//setup choices.js
let cityChoices;
let venueChoices;
let kindChoices;
prom.then(function(){
    const cityElement = document.querySelector('.cities-select');
    cityChoices = new Choices(cityElement);
    const venueElement = document.querySelector('.venues-select');
    venueChoices = new Choices(venueElement);
    const kindElement = document.querySelector('.kinds-select');
    kindChoices = new Choices(kindElement);
});

//get params
let script = document.querySelector('.bil24');
let pa = script.src.split("?").pop().split("&");
let p = {};
for(var j=0; j < pa.length; j++) {
    let kv = pa[j].split("=");
    p[kv[0]] = kv[1];
}

//send api request
function sendRequest(){
    let zone = p.zone;
    let url;
    if(zone == "real"){
        url = "https://api.bil24.pro/json";
    }else{
        url = "https://api.bil24.pro:1240/json";
        zone = "test";
    }
    let request = {
        fid: Number(p.fid),
        token: p.token,
        locale: "ru",
        command: "GET_ALL_ACTIONS"
    };
    
    const xhr = new XMLHttpRequest();
    xhr.open('POST', url);
    xhr.responseType = 'json';
    xhr.setRequestHeader('Content-Type', 'application/json');
    xhr.onload = () => {
        
        let result = xhr.response;
        let actions = result.actionList;  
        console.log(result);
        let cityList = new Map();
        let kindList = new Map();
        let venueList = new Map();
        let venueCityList = new Map();
        
        
        //droplist city
        prom.then(function(){
            for(let i in result.cityList){
                cityChoices.setValue([result.cityList[i].cityName]);
                cityList.set(result.cityList[i].cityId, result.cityList[i].cityName);
            
            
        //droplist venue
                for(let j in result.cityList[i].venueList){
                    venueChoices.setValue([result.cityList[i].venueList[j].venueName]);
                    venueList.set(result.cityList[i].venueList[j].venueId, result.cityList[i].venueList[j].venueName);
                    venueCityList.set(result.cityList[i].venueList[j].venueId, result.cityList[i].cityId);
                }
            }
            cityChoices.setChoiceByValue('');
            venueChoices.setChoiceByValue('');
        });
        
        
        //droplist kind
        prom.then(function(){
            for(let i in result.kindList){
                kindChoices.setValue([result.kindList[i].kindName]);
                kindList.set(result.kindList[i].kindId, result.kindList[i].kindName);
            }   
            kindChoices.setChoiceByValue('');
        });


        //create all cards    
        let tempCityId;
        let tempVenueId;
        let elem = '';  
        let tempCityIdList = [];
        let tempVenueIdList = [];
        for(let i = actions.length - 1; i >= 0; i--){
            tempCityId = -1;
            tempVenueId = -1;
            for(let j in actions[i].actionEventList){
                if(tempCityId != actions[i].actionEventList[j].cityId){
                    tempCityIdList.push(actions[i].actionEventList[j].cityId);
                    tempCityId = actions[i].actionEventList[j].cityId;
                }
                if(tempVenueId != actions[i].actionEventList[j].venueId){
                    tempVenueIdList.push(actions[i].actionEventList[j].venueId);
                    tempVenueId = actions[i].actionEventList[j].venueId;
                }

            }
            
                elem = '<a href="/widget/#/?frontendId=' + p.fid + '&token=' + p.token + '&id=' + actions[i].actionId + '&cityId=' + actions[i].actionEventList[0].cityId + '&agr=' + location.protocol + '//' + location.hostname + '/bil24-wp-script/agreement/agreement.html&zone=' + zone + '" class="events__event" data-cityid= "' + tempCityIdList + '" data-kindid="' + actions[i].kindId + '" data-venueid="' +tempVenueIdList +'"><div class="event__img_wrapper"><img src="'+ actions[i].smallPosterUrl + '" alt="" class="event__img"></div><p class="event__name">' + actions[i].actionName + '</p><span class="event__inf">' + actions[i].fullActionName + '</span><span class="event__inf">' + actions[i].firstEventDate + '</span><span class="event__inf">' + actions[i].actionEventTime + '</span><span class="event__inf">от ' + actions[i].minPrice + ' руб.</span></a>';
                document.querySelector(".wrapper__events").insertAdjacentHTML('afterbegin', elem);
                tempCityIdList = [];
                tempVenueIdList = [];
        }


        //listeners
        let actionsDOM = document.querySelectorAll(".events__event");
        prom.then(function(){
            cityChoices.passedElement.element.addEventListener('change', changeVenues);
            cityChoices.passedElement.element.addEventListener('change', search);   
            venueChoices.passedElement.element.addEventListener('change', search);
            kindChoices.passedElement.element.addEventListener('change', search);
        });
        
        
        //search
        function search(){
            let cityValue = cityChoices.getValue(true).toLowerCase().trim();
            let venueValue = venueChoices.getValue(true).toLowerCase().trim();
            let kindValue = kindChoices.getValue(true).toLowerCase().trim();
            let cityIdList = [];
            let venueIdList = [];
            let venueIdInCurrentCity;
            for(let i = 0; i < actionsDOM.length; i++){
                cityIdList = actionsDOM[i].getAttribute('data-cityid').split(',');
                venueIdList = actionsDOM[i].getAttribute('data-venueid').split(',');
                for(let city in cityIdList){
                    new_card:
                    for (let venue in venueIdList){
                        if(cityList.get(Number(cityIdList[city])).toLowerCase().trim().includes(cityValue)
                           && venueList.get(Number(venueIdList[venue])).toLowerCase().trim().includes(venueValue)
                           && kindList.get(Number(actionsDOM[i].getAttribute('data-kindid'))).toLowerCase().trim().includes(kindValue)){
                            actionsDOM[i].style.display = "flex";
                            break new_card;
                        }else {
                            actionsDOM[i].style.display = "none";
                        }                   
                        
                    }
                }
                

                
            }
            
        }
        
        
        //change inputs
        function changeVenues(){
            if(cityChoices.getValue(true).toLowerCase().trim() == ''){
                venueChoices.clearChoices();
                for(let i in result.cityList){
                    for(let j in result.cityList[i].venueList){
                        venueChoices.setValue([result.cityList[i].venueList[j].venueName]);
                    }
                }
                venueChoices.setChoices([{ value: '', label: 'Площадка', placeholder:true,selected:true }], 'value', 'label', false);
                venueChoices.setChoiceByValue('');
            }else{
                for (let [cityId, v] of cityList) {
                    if (v.toLowerCase().trim() == cityChoices.getValue(true).toLowerCase().trim()) { 
                        const CVK = result.cityList;
                        venueChoices.clearChoices();
                        for(let i in CVK){
                            if(CVK[i].cityId == cityId){
                                for(let j in CVK[i].venueList)
                                venueChoices.setValue([CVK[i].venueList[j].venueName]);
                            }
                        }
                        venueChoices.setChoices(
                            [{ value: '', label: 'Площадка', placeholder:true,selected:true }], 'value', 'label', false);
                        break;
                    }

                }  
            }

        }
        
    }
    xhr.send(JSON.stringify(request));
}

sendRequest();